//*****************************************************************************
//*
//*
//*		ks_emulation.c
//*
//*
//*****************************************************************************
#include	"ks_emulation.h"
#include	"sys_arch_rt.h"
#include	<rttbios.h>
#include	<pci.h>


#define		KS_EXIT_ISR()
#define		KS_ENTER_ISR()
#define 	KS_NUM_INTS					16
#define		MAX_INTERFACES				4
#define		RTSPINLOCK(SFlags,SName)    {0,0xFF,0,SFlags,SName,0}
#define 	STACK_SIZE					0x4000


static	struct _iface	lwip_interfaces[MAX_INTERFACES];
static	unsigned		lwip_interf_cnt = 0;
PIFACE   				ifaces=lwip_interfaces;

static  void			ks_kernel_init(void);
extern  void           *memp_info(memp_t type,int *size);
extern  const char     *IpGetHostname();
extern  int				IpSetHostname(const char *pName);
extern  BOOL _stdcall	HeapFree(HANDLE  hHeap,DWORD dwFlags,LPVOID lpMem);
extern  LPVOID _stdcall HeapAlloc(HANDLE  hHeap,DWORD dwFlags,DWORD dwBytes);
extern  HANDLE _stdcall GetProcessHeap(void);
extern  long   _stdcall InterlockedIncrement(long *pAddend);
extern  long   _stdcall InterlockedDecrement(long *pAddend);
extern  RTKTaskHandle  _rtk_CurrentTask;

unsigned				PRIOTASK_NORMAL;
int						CFG_ETHERNET_MODE [MAX_INTERFACES] = {0};
RTIPINTFN_POINTER		rtip_isr_interrupt[KS_NUM_INTS];
RTIPINTFN_POINTER		rtip_isr_strategy [KS_NUM_INTS];
PIFACE					rtip_irq_iface    [KS_NUM_INTS];
int						rtip_args         [KS_NUM_INTS];
static char				dummy_buf[16];
EPACKET					dummy_dcu;
int						dcu_size_array[5] = {CFG_MAX_PACKETSIZE+4,CFG_MAX_PACKETSIZE+4,CFG_MAX_PACKETSIZE+4,CFG_MAX_PACKETSIZE+4,CFG_MAX_PACKETSIZE+4};


//*****************************************************************************
//*
//*		INTERRUPT SERVICE ROUTINES
//*
//*****************************************************************************
void __cdecl rtip_c_isr_0(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(0);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_1(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(1);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_2(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(2);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_3(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(3);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_4(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(4);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_5(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(5);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_6(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(6);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_7(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(7);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_8(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(8);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_9(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(9);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_10(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(10);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_11(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(11);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_12(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(12);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_13(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(13);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_14(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(14);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_15(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(15);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_16(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(16);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_17(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(17);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_18(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(18);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_19(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(19);
    KS_EXIT_ISR();
}
void __cdecl rtip_c_isr_20(void)
{
    KS_ENTER_ISR();
    ks_dispatch_interrupt(20);
    KS_EXIT_ISR();
}

RTIntHandler intfn_array[KS_NUM_INTS] =
{
    rtip_c_isr_0 ,rtip_c_isr_1 ,rtip_c_isr_2 ,rtip_c_isr_3,
    rtip_c_isr_4 ,rtip_c_isr_5 ,rtip_c_isr_6 ,rtip_c_isr_7,
    rtip_c_isr_8 ,rtip_c_isr_9 ,rtip_c_isr_10,rtip_c_isr_11,
    rtip_c_isr_12,rtip_c_isr_13,rtip_c_isr_14,rtip_c_isr_15,
	#if (KS_NUM_INTS>16)
    rtip_c_isr_16,
	#endif
	#if (KS_NUM_INTS>17)
    rtip_c_isr_17,
	#endif
	#if (KS_NUM_INTS>18)
    rtip_c_isr_18,
	#endif
	#if (KS_NUM_INTS>19)
    rtip_c_isr_19,
	#endif
	#if (KS_NUM_INTS>20)
    rtip_c_isr_20,
	#endif
	#if (KS_NUM_INTS>21)
	#error Make more initializers to intfn_array[] (osint.c).
	#endif
    };

//*****************************************************************************
//*
//*		outsw
//*
//*****************************************************************************
void outsw(IOADDRESS ioaddr,const unsigned short *src,int n)
{
	_asm{
		pushf
		push    esi
		mov     dx, ioaddr
		mov     ecx, n
		mov     esi, src
		rep     outsw
		pop     esi
		popf
		}
}

//*****************************************************************************
//*
//*		outsb
//*
//*****************************************************************************
void outsb(IOADDRESS ioaddr,const unsigned char *src, int n)
{
	_asm{
		pushf
		push    esi
		mov     dx, ioaddr
		mov     ecx, n
		mov     esi, src
		rep     outsb
		pop     esi
		popf
		}
}

//*****************************************************************************
//*
//*		insw
//*
//*****************************************************************************
void insw(IOADDRESS ioaddr,unsigned short *dst,int n)
{
	_asm{
		pushf
		push    edi
		mov     dx, ioaddr
		mov     edi, dst
		mov     ecx, n
		rep     insw
		pop     edi
		popf
		}
}

//*****************************************************************************
//*
//*		insb
//*
//*****************************************************************************
void insb(IOADDRESS ioaddr,unsigned char *dst,int n)
{
	_asm{
		pushf
		push    edi
		mov     dx, ioaddr
		mov     edi, dst
		mov     ecx, n
		rep     insb
		pop     edi
		popf
		}
}

//*****************************************************************************
//*
//*		ms_pm_inp
//*
//*****************************************************************************
/* 32 Bit MSC generates the wrong code for _inp. so here it is   */
byte ms_pm_inp(unsigned short addr)
{
unsigned short mydx;
unsigned char  b;

    _asm{
        mov  mydx, dx
        mov  dx, addr
        in   al, dx
        mov  b , al
        mov  dx, mydx
		}

return b;
}

//*****************************************************************************
//*
//*		set_errno
//*
//*****************************************************************************
int set_errno(int error)
{
return -1;
}

//*****************************************************************************
//*
//*		debug_error
//*
//*****************************************************************************
void debug_error(const char *string,int type,dword val1,dword val2)
{
	#ifndef NDEBUG
	printf("%s %i %i %i\n",string,type,val1,val2);
	#endif
}

//*****************************************************************************
//*
//*		ks_spin_lock
//*
//*****************************************************************************
unsigned ks_splx(void)
{
SYS_ARCH_DECL_PROTECT(lev);

return SYS_ARCH_PROTECT(lev);
}

//*****************************************************************************
//*
//*		ks_spin_unlock
//*
//*****************************************************************************
void ks_spl(unsigned lev)
{
	SYS_ARCH_UNPROTECT(lev);
}

//*****************************************************************************
//*
//*		ks_sleep
//*
//*****************************************************************************
void ks_sleep(dword no_ticks)
{
    RTKDelay(no_ticks);
}

//*****************************************************************************
//*
//*		ks_get_ticks
//*
//*****************************************************************************
dword ks_get_ticks(void)
{
return RTKGetTime();
}

//*****************************************************************************
//*
//*		ks_msec_p_tick
//*
//*****************************************************************************
dword ks_msec_p_tick(void)
{
unsigned long temp = CLKSecondsToTicks(1);

    if (temp < 1000ul)
        return 1000ul / temp;
    else
        return 1;
}

//*****************************************************************************
//*
//*		ks_ticks_p_sec
//*
//*****************************************************************************
unsigned long ks_ticks_p_sec(void)
{
    return CLKSecondsToTicks(1);
}

//*****************************************************************************
//*
//*		ks_pi_task
//*
//*****************************************************************************
static void _cdecl ks_pi_task(void *param)
{
PIFACE		pi=(PIFACE)param;


	for(;;)
		{
		RTKWait(pi->irq_signal);

        if(rtip_isr_strategy[pi->irq_val])				// call that strategy routine passed to ks_hook_interrupt
			{
            rtip_isr_strategy[pi->irq_val](rtip_args[pi->irq_val]);
			}
		}


}

//*****************************************************************************
//*
//*		ks_dispatch_interrupt
//*
//*****************************************************************************
void ks_dispatch_interrupt(int irq)
{


    if(rtip_irq_iface[irq])								// interrupt processing to be done by interrupt task
		{
        if(rtip_isr_interrupt[irq])						// if it exists then call
			{
            rtip_isr_interrupt[irq](rtip_args[irq]);    // special driver interrupt entry code
			}

		RTKSignal(rtip_irq_iface[irq]->irq_signal);
		}
    else{												// directly isr
		if(rtip_isr_strategy[irq])
			{
			rtip_isr_strategy[irq](rtip_args[irq]);
			}
		}


}

//*****************************************************************************
//*
//*		ks_invoke_interrupt
//*
//*****************************************************************************
void ks_invoke_interrupt(PIFACE pi)
{
static unsigned if_map;
int				if_no;


	if_map = 0;
	if_no  = pi-lwip_interfaces;

    if(!(if_map&(1<<if_no)))
		{
        if_map |= 1<<if_no;
        ks_kernel_init();
		}

	RTKSignal(pi->irq_signal);						// signal directly because signals are legal from isr

}


//*****************************************************************************
//*
//*		ks_pool_init
//*
//*****************************************************************************
//	maps all buffers are to pysical memory
void ks_pool_init(void)
{
void   *mem;
void   *phy;
int		pool;
int		size;
int		ret;


	for(pool=0;;pool++)
		{
			mem = memp_info(pool,&size);
		if(!mem)break;

		phy  = RTGetPhysAddress(mem);
		ret  = RTMapMem(phy,phy,size,RT_PG_USERREADWRITE);
		}

}

//*****************************************************************************
//*
//*		ks_maptophy
//*
//*****************************************************************************
//	tranlate a virtual buffer address to a physical address
void ks_maptophy(void **memp)
{
	*memp = RTGetPhysAddress(*memp);
}


//*****************************************************************************
//*
//*		ks_invoke_output
//*
//*****************************************************************************
void ks_invoke_output(PIFACE pi,int xmit_complete_cnt)
{
int volatile	*xptr;


	#if !(INCLUDE_XMIT_QUE)
	xmit_complete_cnt = 1;
	#endif

    xptr = &pi->xmit_done_counter;

	_asm{
		mov			eax,xmit_complete_cnt
		mov			ecx,xptr
		lock add	dword ptr [ecx],eax
		}

	RTKSignal(pi->out_signal);

}


//*****************************************************************************
//*
//*		ks_invoke_input
//*
//*****************************************************************************
//	packet on interface received
void ks_invoke_input(PIFACE pi,DCU dcu)
{
struct pbuf	     *buf;
unsigned		  err;



	PIPE_STATS_INC(pipe.input);

	buf			= (struct pbuf *)dcu->buffer;
	buf->len	= dcu->length;
	err			= pi->lpip_iface.input(buf,&pi->lpip_iface);

	if(err!=ERR_OK)
		{
		if(_rtk_CurrentTask->CurrIRQ!=-1)									// call from ISR
			{
			pbuf_free(dcu->buffer);
			PIPE_STATS_INC(pipe.inperr);
			return;
			}

		RTKDelay(1);

		err = pi->lpip_iface.input(buf,&pi->lpip_iface);

		if(err!=ERR_OK)
			{
			RTKDelay(1);

			err = pi->lpip_iface.input(buf,&pi->lpip_iface);

			if(err!=ERR_OK)
				{
				pbuf_free(dcu->buffer);
				PIPE_STATS_INC(pipe.inperr);
				}
			}
		}

}

//*****************************************************************************
//*
//*		ks_hook_interrupt
//*
//*****************************************************************************
RTIP_BOOLEAN ks_hook_interrupt(int irq,PFVOID piface,RTIPINTFN_POINTER c_strategy,RTIPINTFN_POINTER c_interrupt,int c_arg)
{
RTIntHandler	isr_func;



	if(irq>(KS_NUM_INTS-1))							// Check irq number
		{
		return FALSE;
		}

    rtip_irq_iface[irq] = piface;					// Signal this iface if non null

    if(piface)
		{
        ((PIFACE)piface)->irq_no = irq; 			// The interrupt task passes this
                                        			// to the Interrupt service routine
													// wake up the interrupt task to start                                */
        ks_invoke_interrupt(piface);
		}

													// save the name of the routine to be call from the interrupt
    rtip_isr_interrupt[irq] = c_interrupt;			// This is usually null unless
	rtip_isr_strategy [irq] = c_strategy;
	rtip_args         [irq] = c_arg;

	isr_func = intfn_array[irq];

	RTInstallSharedIRQHandler(irq,isr_func);



return  TRUE;
}

//*****************************************************************************
//*
//*		ks_kernel_init
//*
//*****************************************************************************
static void ks_kernel_init(void)
{


}


//*****************************************************************************
//*
//*		ks_send_packet
//*
//*****************************************************************************
static err_t ks_send_packet(struct netif *netif,struct pbuf *buf)
{
struct pbuf			   *q;
PIFACE					pi=(PIFACE)netif;
EPACKET					dcu;
unsigned				pos;
err_t					err;
int	volatile		   *xptr;



	if(!buf || !pi)return ERR_ARG;


	if(pi->xmit_done_counter>0)						// are the last packed transmitted
        {
		xptr = &pi->xmit_done_counter;

		LockSub(xptr,1);

		if(!pi->pdev->xmit_done(pi,&dummy_dcu,1))
			{
			RTKWaitTimed(pi->out_signal,1);
			}
		else{
			RTKWaitTimed(pi->out_signal,0);
			}
		}


	if(!RTKWaitTimed(pi->sem,pi->max_wait))
		{
		return ERR_TIMEOUT;
		}


	if(pi->send_buf)								// free last sended packet
		{
		pbuf_free(pi->send_buf);
		pi->send_buf = 0;
		}


	err = ERR_OK;

	if(buf->next)									// packet with multiple buffers
		{
		pos = 0;

		for(q=buf;q!=NULL;q=q->next)
			{
			if(pos+q->len>ETHERSIZE)
				{
				RTKSignal(pi->sem);
				return ERR_BUF;
				}

			memcpy(pi->buffer+pos,q->payload,q->len);
			pos = pos + q->len;
			}

		dcu.length	= pos;
		dcu.data	= pi->buffer;
		dcu.who		= IFEACE_BUFFER;
		}
	else{											// packet with a single buffer
		if(buf->len>ETHERSIZE)
			{
			RTKSignal(pi->sem);
			return ERR_BUF;
			}

		dcu.length	= buf->len;
		dcu.data	= buf->payload;
		dcu.who		= LIIP_BUFFER;

		pi->send_buf= buf;
		buf->ref   += 1;
		}

	dcu.buffer	= buf;

	if(pi->pdev->xmit(pi,&dcu))						// transmitt packet
		{
		err = ERR_IF;								// transmitt error
		PIPE_STATS_INC(pipe.outerr);
		}

	RTKSignal(pi->sem);

	PIPE_STATS_INC(pipe.output);



return err;
}


//*****************************************************************************
//*
//*		os_free_packet
//*
//*****************************************************************************
void os_free_packet(DCU msg)
{

	if(!msg)return;

	if(msg->RefCount>0 && InterlockedDecrement(&msg->RefCount))
		{
        return;
		}

	pbuf_free(msg->buffer);

}

//*****************************************************************************
//*
//*		os_alloc_packet_input
//*
//*****************************************************************************
DCU	os_alloc_packet_input(int nbytes, int who)
{
struct pbuf	   *buf;
unsigned		off;
DCU			 	dcu;



	off = (nbytes+7)&~7;
	buf	= pbuf_alloc(PBUF_RAW,off+sizeof(EPACKET)+8,PBUF_RAM);

	if(!buf)return 0;

	dcu = (DCU)(((char*)buf->payload)+off);

	dcu->buffer			= buf;
	dcu->length 		= off;
	dcu->who			= who;
	dcu->ChkSumOffload	= 0;
	dcu->RefCount		= 1;
	dcu->data			= buf->payload;



return dcu;
}


static HANDLE	HeapHandle    = NULL;
static int		IsProcessHeap = 0;

//*****************************************************************************
//*
//*		PhysFree
//*
//*****************************************************************************
void PhysFree(void *B, int size, int num_elements)
{
    HeapFree(HeapHandle,0,B);
}

//*****************************************************************************
//*
//*		PhysMalloc
//*
//*****************************************************************************
void *PhysMalloc(UINT Bytes, int who)
{
void  *Result;


	if(HeapHandle == NULL)
		{
		HeapHandle = RTGetProcessPhysMemHeap();

		if(HeapHandle == NULL)
			{
			HeapHandle = GetProcessHeap();					// this never fails
			IsProcessHeap = 1;
			}
		}

    Result = HeapAlloc(HeapHandle, 0, Bytes);

    if(IsProcessHeap)										// check that it's phys=virt address
		{
        const BYTE * Start = (const BYTE*)((DWORD)(Result)&0xFFFFF000);
        const BYTE * End   = Start + Bytes;

        while(Start<End)
			{
            if(RTGetPhysAddress(Start) != Start)
				{
                DEBUG_ERROR("PhysMalloc: can't allocate physical memory, need virtual memory manager", 0, 0, 0);
                PhysFree(Result, Bytes, 1);
                return 0;
				}

			Start += 4096;
			}
		}


return Result;
}

extern int __rttMaxPCIBusses;

//*****************************************************************************
//*
//*		rtpci_LocateDevice
//*
//*****************************************************************************
int rtpci_LocateDevice(const rtpci_device_table *pci_tab,PIFACE pi,int IOBaseReg,dword * PCILocation)
{
BYTE		Bus,Dev,Func,MaxFunc,Header;
DWORD		VendorDevice;
WORD		W;
int			Result;
int			Index;


	Index = (pi)? pi->minor_number:IOBaseReg;

	for(Bus=0;Bus<__rttMaxPCIBusses;Bus++)
	for(Dev=0;;Dev+=8)
		{
																// try to read vendor/device id
		   Result =  RTT_BIOS_ReadConfigData(Bus,Dev,RTT_BIOS_VENDOR_ID,sizeof(DWORD),&VendorDevice);
		if(Result == RTT_BIOS_FNC_NOT_SUPPORTED)
			{
			return -1;											// No PCI BIOS
			}

		if(Result!=RTT_BIOS_SUCCESSFUL || VendorDevice==0xFFFFFFFF)
		if(Dev==0x0100-8) 										// this is the last possible device
			{
			break;
			}
		else{
			continue;											// no device here
			}

																// get the header type
		RTT_BIOS_ReadConfigData(Bus,Dev,RTT_BIOS_HEADERTYPE,sizeof(BYTE),&Header);
		MaxFunc = (Header & 0x80) ? 8 : 1;

		for(Func=0;Func<MaxFunc;Func++)
			{
			const rtpci_device_table * p = pci_tab;				// is this one in our list?

			if(Func)
				{
																// read vendor/device
				   Result = RTT_BIOS_ReadConfigData(Bus,Dev|Func,RTT_BIOS_VENDOR_ID,sizeof(DWORD),&VendorDevice);
				if(Result!= RTT_BIOS_SUCCESSFUL || VendorDevice == 0xFFFFFFFF)
					{
					continue;									// no device here
					}
				}

			while(p->VendorID)
				{
				if(VendorDevice == (DWORD)(((p->DeviceID << 16) | p->VendorID)))
				if(Index-- == 0)
					{
																// found
					if(PCILocation)
						{
						*PCILocation = (Bus<<8)|Dev|Func;
						}

					if(pi)
						{
						pi->pdev->device_name = p->Name;

																// read the irq
						RTT_BIOS_ReadConfigData(Bus,Dev|Func,RTPCI_REG_INT_LINE,1,&Header);
						pi->irq_val = Header;
																// read the I/O Base Register
						RTT_BIOS_ReadConfigData(Bus,Dev|Func,IOBaseReg,4,&pi->io_address);

						if(pi->io_address&1)					// I/O
							{
							pi->io_address &= 0x0000FFFC;
							}
						else{
							pi->io_address &= 0xFFFFFF00;
							}

																// enabling Bus Mastering (BMEM) and enabling I/O accesses (IOEN)
						RTT_BIOS_ReadConfigData (Bus,Dev|Func,RTPCI_REG_CMD,2,&W);
						RTT_BIOS_WriteConfigData(Bus,Dev|Func,RTPCI_REG_CMD,2, W|RTPCI_M_CMD_IOEN|RTPCI_M_CMD_BMEM);
						RTT_BIOS_ReadConfigData (Bus,Dev|Func,PCI_LATENCY_TIMER,1,&Header);

						if(Header < 32)
							{
							RTT_BIOS_WriteConfigData(Bus,Dev|Func,PCI_LATENCY_TIMER,1,32);
							}
						}

					return p - pci_tab;
					}

				p++;
				}
			}

		if(Dev==0x0100-8) 										// this is the last possible device
			{
			break;
			}
		}

return -1;														// not found
}

//*****************************************************************************
//*
//*		arp_timer
//*
//*****************************************************************************
static void arp_timer(void *arg)
{
	etharp_tmr();
	sys_timeout(ARP_TMR_INTERVAL,arp_timer,NULL);
}


//*****************************************************************************
//*
//*		xn_device_table_add
//*
//*****************************************************************************
int xn_device_table_add(EDEVTABLE *dev,int minor_number)
{


	if(lwip_interf_cnt>=MAX_INTERFACES)
		{
		return -1;
		}

	memset (lwip_interfaces+lwip_interf_cnt,0,sizeof(struct _iface));
	sprintf(lwip_interfaces[lwip_interf_cnt].name    ,"LWIP_IF_%i"    ,lwip_interf_cnt);
	sprintf(lwip_interfaces[lwip_interf_cnt].name_out,"LWIP_IF_%i_OUT",lwip_interf_cnt);
	sprintf(lwip_interfaces[lwip_interf_cnt].name_irq,"LWIP_IF_%i_IRQ",lwip_interf_cnt);

	lwip_interfaces[lwip_interf_cnt].minor_number	= minor_number;
	lwip_interfaces[lwip_interf_cnt].lpip_iface.num	= lwip_interf_cnt;
	lwip_interfaces[lwip_interf_cnt].number			= lwip_interf_cnt;
	lwip_interfaces[lwip_interf_cnt].pdev			= dev;
	lwip_interfaces[lwip_interf_cnt].sem			= RTKCreateSemaphore(ST_COUNTING,1,lwip_interfaces[lwip_interf_cnt].name);
	lwip_interfaces[lwip_interf_cnt].irq_signal		= RTKCreateSemaphore(ST_COUNTING,0,lwip_interfaces[lwip_interf_cnt].name_irq);
	lwip_interfaces[lwip_interf_cnt].out_signal		= RTKCreateSemaphore(ST_EVENT   ,0,lwip_interfaces[lwip_interf_cnt].name_out);
	lwip_interfaces[lwip_interf_cnt].max_wait		= CLKMilliSecsToTicks(5);

	RTKCreateThread(ks_pi_task,PRIOTASK_NORMAL,STACK_SIZE,0,lwip_interfaces+lwip_interf_cnt,lwip_interfaces[lwip_interf_cnt].name);

	if(lwip_interfaces[lwip_interf_cnt].max_wait)
		{
		lwip_interfaces[lwip_interf_cnt].max_wait = 1;
		}

	lwip_interf_cnt++;


return 0;
}

//*****************************************************************************
//*
//*		netif_open_config
//*
//*****************************************************************************
struct netif *netif_open_config(int device_id,int minor_number,IOADDRESS io_address,int irq_val,word mem_address)
{
PIFACE		pi;
unsigned	pos;



	pi = lwip_interfaces;

	for(pos=0;;pos++,pi++)
		{
		if(pos>=lwip_interf_cnt)return 0;
		if(pi->pdev->device_id!=device_id   )continue;
		if(pi->minor_number   !=minor_number)continue;

		break;
		}


	if(io_address==0)
			pi->io_address  = (IOADDRESS)(pi->pdev->default1.io_address);
	else	pi->io_address  = io_address;

	if (irq_val==-1)
            pi->irq_val     = pi->pdev->default3.irq;
    else	pi->irq_val     = irq_val;

    if(mem_address==0)
            pi->mem_address = pi->pdev->default2.mem_address;
	else	pi->mem_address = mem_address;


	pi->addr.my_ip_mask[0]	= 0xFF;
    pi->addr.my_ip_mask[1] 	= 0xFF;
    pi->addr.my_ip_mask[2] 	= 0xFF;
    pi->addr.my_ip_mask[3] 	= 0x00;


	if(!pi->pdev->open(pi))
		{
		return 0;
		}



return &pi->lpip_iface;
}


//*****************************************************************************
//*
//*		interface_init
//*
//*****************************************************************************
//	callback for netif_add(...)
err_t netif_init_cb(struct netif *netif)
{
PIFACE		pi=(PIFACE)netif;
unsigned	num;




	num = netif->num;

	LWIP_ASSERT("netif != NULL", (netif!=NULL));
	LWIP_ASSERT("netif->num   ", (num<MAX_INTERFACES));

	memcpy(netif->hwaddr,pi->addr.my_hw_addr,6);


	#if LWIP_NETIF_HOSTNAME								// Initialize interface hostname
		netif->hostname =  IpGetHostname();				// see at SocketUtility.cpp
	if(*netif->hostname==0)IpSetHostname("lwip");
	#endif

	netif->name[0]		= 'e';
	netif->name[1]		= '0'+netif->num%8;
	netif->flags	   |= NETIF_FLAG_ETHARP;
	netif->flags	   |= NETIF_FLAG_LINK_UP;
	netif->flags	   |= NETIF_FLAG_BROADCAST;
	netif->output		= etharp_output;
	netif->linkoutput	= ks_send_packet;
	pi->buffer			= (unsigned char*)PhysMalloc(ETHERSIZE+256,PACKET_POOL_MALLOC);
	pi->send_buf		= 0;

	dummy_dcu.data		= dummy_buf;
	dummy_dcu.buffer	= 0;
	dummy_dcu.length	= 0;
	dummy_dcu.who		= 0;


	etharp_init();
	sys_timeout(ARP_TMR_INTERVAL,arp_timer,NULL);




return ERR_OK;
}

//*****************************************************************************
//*
//*		rtpci_find_device
//*
//*****************************************************************************
unsigned char rtpci_find_device (unsigned short DeviceID, unsigned short VendorID,
                                 int Index, unsigned char *BusNum,
                                 unsigned char *DevFncNum)
{
    return RTT_BIOS_FindDevice(VendorID, DeviceID, Index, BusNum, DevFncNum);
}


//*****************************************************************************
//*
//*		rtpci_read_byte
//*
//*****************************************************************************
unsigned char rtpci_read_byte(unsigned char BusNum, unsigned char DevFncNum,
                              int RegNum, unsigned char *ByteRead)
{
   return RTT_BIOS_ReadConfigData(BusNum, DevFncNum, RegNum, 1, ByteRead);
}

//*****************************************************************************
//*
//*		rtpci_read_word
//*
//*****************************************************************************
unsigned char rtpci_read_word(unsigned char BusNum, unsigned char DevFncNum,
                              int RegNum, unsigned short *WordRead)
{
   return RTT_BIOS_ReadConfigData(BusNum, DevFncNum, RegNum, 2, WordRead);
}

//*****************************************************************************
//*
//*		rtpci_read_dword
//*
//*****************************************************************************
unsigned char rtpci_read_dword(unsigned char BusNum, unsigned char DevFncNum,
                               int RegNum, unsigned long *DWordRead)
{
   return RTT_BIOS_ReadConfigData(BusNum, DevFncNum, RegNum, 4, DWordRead);
}

//*****************************************************************************
//*
//*		rtpci_write_byte
//*
//*****************************************************************************
unsigned char rtpci_write_byte(unsigned char BusNum, unsigned char DevFncNum,
                               int RegNum, unsigned char ByteWrite)
{
    return RTT_BIOS_WriteConfigData(BusNum, DevFncNum, RegNum, 1, ByteWrite);
}

//*****************************************************************************
//*
//*		rtpci_write_word
//*
//*****************************************************************************
unsigned char rtpci_write_word(unsigned char BusNum, unsigned char DevFncNum,
                               int RegNum, unsigned short WordWrite)
{
    return RTT_BIOS_WriteConfigData(BusNum, DevFncNum, RegNum, 2, WordWrite);
}

//*****************************************************************************
//*
//*		rtpci_write_dword
//*
//*****************************************************************************
unsigned char rtpci_write_dword(unsigned char BusNum, unsigned char DevFncNum,
                                int RegNum, unsigned long DWordWrite)
{
    return RTT_BIOS_WriteConfigData(BusNum, DevFncNum, RegNum, 4, DWordWrite);
}



