//*****************************************************************************
//*
//*
//*		ks_emulation.h
//*
//*
//*****************************************************************************
#ifndef 	__KS_EMULATION_H__
#define 	__KS_EMULATION_H__


#define 	LWIP_PROVIDE_NO_ERRNO
#include	<rttarget.h>
#include	<string.h>
#include	<rtk32.h>
#include	<clock.h>
#include	<finetime.h>
#include	"lwip/sys.h"
#include	"lwip/mem.h"
#include	"lwip/memp.h"
#include	"lwip/arch.h"
#include	"lwip/dhcp.h"
#include	"lwip/stats.h"
#include	"lwip/tcpip.h"
#include	"lwip/sockets.h"
#include	"netif/etharp.h"
#include	"ipv4/lwip/ip_addr.h"

#define 	KS_FAR
#define 	TRUE					1
#define 	FALSE					0
#define 	MINOR_0					0
#define 	MINOR_1					1
#define 	MINOR_2					2
#define 	MINOR_3					3
#define 	ETHER_IFACE				1
#define 	NULLP_FUNC				0
#define 	KS_LITTLE_ENDIAN		1
#define 	KS_CONSTANT				const
#define 	SMC91C9X_DEVICE			5
#define		I8254X_DEVICE			46
#define		RDC6040_DEVICE          49
#define 	R8168_DEVICE            48
#define 	SNMP_DEVICE_INFO(a,b)
#define		IP_ALEN					4 
#define		ETH_ALEN				6 
#define		IP_LEN					IP_ALEN
#define		TOK_ALEN				6
#define 	LL_ALEN  				6
#define 	ETHERSIZE  				1514
#define 	ETHER_MIN_LEN			60
#define 	ETHER_NOCHK_MIN_LEN		60
#define 	SMC91C9X_PCMCIA_DEVICE	6
#define		ENUMDEVICE				31 
#define		ENETDOWN				24
#define 	RTIP_VERSION			41
#define		DRIVER_ALLOC			13 
#define		IFEACE_BUFFER			15
#define		LIIP_BUFFER				16
#define		CFG_MCLISTSIZE			5
#define		CFG_ETHER_MAX_MSS     	1460
#define 	CFG_ETHER_MAX_MTU     	1500
#define 	CFG_ETHER_MAX_WIN_IN  	(CFG_ETHER_MAX_MSS*8)
#define 	CFG_ETHER_MAX_WIN_OUT 	(CFG_ETHER_MAX_MSS*8)
#define 	CFG_RS232_MAX_MSS     	 CFG_ETHER_MAX_MSS     /* was 216 but max value seems better */
#define 	CFG_RS232_MAX_MTU     	 CFG_ETHER_MAX_MTU     /* was 256 but max value seems better */
#define 	CFG_RS232_MAX_WIN_IN  	(CFG_RS232_MAX_MSS*4)
#define 	CFG_RS232_MAX_WIN_OUT 	(CFG_RS232_MAX_MSS*4)
#define		IOADD(X)				{(IOADDRESS)(X)}
#define		EN(X)					{X}
#define		DEBUG_ERROR(STR,TYPE,X1,X2)	
#define		DEBUG_LOG(STR,LEVEL,TYPE,X1,X2) 
#define		OUTDWORD(ADD,VAL)		RTOutD(ADD,(unsigned long )(VAL))
#define		OUTWORD(ADD,VAL)		RTOutW(ADD,(unsigned short)(VAL))
#define		OUTBYTE(ADD,VAL)		RTOut (ADD,(unsigned char )(VAL))
#define		INDWORD(ADD)			RTInD (ADD)
#define		INWORD(ADD)				RTInW (ADD)
#define		INBYTE(ADD)				RTIn  (ADD)
#define		EPROBEFAIL				(34) 
#define		ENOPKTS					(26) 
#define		tc_memset(A,B,C)        memset ((A),(B),(C))
#define		tc_movebytes(A,B,C)     memcpy ((A),(B),(C))
#define		tc_comparen(A,B,C)      (memcmp((A),(B),(C))==0)
#define		DCUTOPACKET(X)			(((DCU)(X)))
#define		DCUTODATA(X)			(((DCU)(X))->data)
#define		DRIVER_MASK_ISR_OFF(irq)
#define		DRIVER_MASK_ISR_ON(irq)
#define		ARGSUSED_PVOID(p)		p=p;
#undef		THREAD_CHECK
#define 	THREAD_CHECK();
#define		UPDATE_INFO(X,Y,Z)
#define		UPDATE_SET_INFO(X,Y,Z)
#define		INCR_INFO(X,Y)
#define		ADDR_ADD(addr1,addr2)	((dword)(addr1) + (dword)(addr2))
#define		CONFIG_WHO_BASE_MALLOC	(0x1000)
#define		PACKET_POOL_MALLOC      (CONFIG_WHO_BASE_MALLOC+38)
#define 	Sleep(a)				ThreadSleep(a)
#define 	KS_INTERRUPT_CONTEXT	unsigned int
#define		CFG_ETHERNET_MODE_SIZE	8
#define 	PHY_10BT_HD     		0
#define 	PHY_10BT_FD     		1
#define 	PHY_100BT_HD    		2
#define 	PHY_100BT_FD    		3
#define 	PHY_AUTO        		4
#define		CHKSUM_OFFLOAD_IP_IN    0x00000001
#define 	CHKSUM_OFFLOAD_IP_OUT   0x00000002
#define 	CHKSUM_OFFLOAD_UDP_IN   0x00000004
#define 	CHKSUM_OFFLOAD_UDP_OUT  0x00000008
#define 	CHKSUM_OFFLOAD_TCP_IN   0x00000010
#define 	CHKSUM_OFFLOAD_TCP_OUT  0x00000020
#define		REPORT_XMIT_DONE		0x4000 
#define		CFG_MAX_PACKETSIZE		1514
#ifndef		min
#define		min(a,b)				(((a)<(b))? (a):(b))
#endif 	
#ifndef		KS_EXTERN_GLOBAL_CONSTANT
#define		KS_EXTERN_GLOBAL_CONSTANT extern const
#endif 	
#ifndef 	EOUTAMEM
#define		EOUTAMEM				(43) 
#endif 	
#ifndef 	EIO
#define		EIO						(4) 
#endif 	


extern		int						CFG_ETHERNET_MODE[];
extern		unsigned				PRIOTASK_NORMAL;
typedef		unsigned short			IOADDRESS;	 
typedef		void				  (*RTIPINTFN_POINTER)(int);
typedef		int						RTIP_BOOLEAN;
typedef		unsigned long		   *PFDWORD;
typedef		unsigned short		   *PFWORD;
typedef		unsigned char		   *PFBYTE;
typedef		const unsigned char    *PFCBYTE;
typedef		char				   *PFCHAR;
typedef		const char			   *PFCCHAR;
typedef		unsigned long 			dword;
typedef		unsigned short 			word;
typedef		unsigned char			byte;
//typedef	unsigned int			DWORD;
typedef		unsigned short 			WORD;
typedef		unsigned char			BYTE;
typedef		void				   *PFVOID;
typedef		const void			   *PFCVOID;

void		insw (IOADDRESS ioaddr, unsigned short       * dst, int n);
void 		insb (IOADDRESS ioaddr, unsigned char        * dst, int n);
void 		outsw(IOADDRESS ioaddr, const unsigned short * src, int n);
void 		outsb(IOADDRESS ioaddr, const unsigned char  * src, int n);

void		RTOut (unsigned int addr, unsigned char  val); 
void		RTOutW(unsigned int addr, unsigned short val); 
void		RTOutD(unsigned int addr, unsigned long  val);
BYTE  		RTIn  (unsigned int addr); 
WORD  		RTInW (unsigned int addr); 
DWORD 		RTInD (unsigned int addr);

LONG _stdcall InterlockedIncrement(LONG *lpAddend);
LONG _stdcall InterlockedDecrement(LONG *lpAddend);


struct ether_statistics
{
    long packets_in;
    long packets_out;
    long bytes_in;
    long bytes_out;
    long errors_in;
    long errors_out;
    long packets_lost;
    long one_collision;             			/* one collison occurred, xmit ok */
    long multiple_collisions;       			/* more than one collision, xmit ok */
    long owc_collision;             			/* out of window collison occurred, */
                                    			/* xmit ok   */
    long collision_errors;          			/* excessive collisions, xmit aborted */
    long rx_overwrite_errors;       			/* ring buffer overflow */
    long rx_frame_errors;           			/* packet to large */
    long rx_crc_errors;							
    long rx_fifo_errors;            			/* rx fifo overrun */
    long rx_other_errors;           			/* other errors not counted in SNMP */
                                    			/* statistics (includes ring buffer   */
                                    			/* corrupt, ring buffer overflow,     */
                                    			/* frame alignment error, FIFO        */
                                    			/* overrun, missed packet             */
    long tx_carrier_errors;         			/* carrier sense errors */
    long tx_fifo_errors;            			/* fifo underrun */
    long tx_delayed;                			/* xmit delayed due to medium busy */
    long tx_sqe_errors;             			/* SQE Error */
    long tx_other_errors;           			/* other errors not counted in SNMP */
                                    			/* statistics (includes xmit timeout,      */
                                    			/* remote transmit DMA failed to complete, */
                                    			/* bus error                               */
};	

typedef struct os_list
	{
    struct os_list KS_FAR *pnext;
    struct os_list KS_FAR *pprev;
	}OS_LIST;
											
typedef struct os_list KS_FAR * POS_LIST;		/* head of list */

typedef struct ether_statistics *PETHER_STATS;

typedef struct _mcast_info						/* multicast information   */
{
	int     lenmclist;                  		/* number of address */
	#if (INCLUDE_RUN_TIME_CONFIG)
	byte   *mclist_ip;
	byte   *mclist_eth;
	int    *mcast_cnt;                  		/* number of tasks set up */
												/* each address   */
	#else
	byte    mclist_ip [CFG_MCLISTSIZE * IP_ALEN];
	byte    mclist_eth[CFG_MCLISTSIZE * ETH_ALEN];
	int     mcast_cnt [CFG_MCLISTSIZE]; 		/* number of tasks set up */
												/* each address   */
	#endif

	#if (INCLUDE_IGMP || INCLUDE_IGMP_V2)
	#if (INCLUDE_RUN_TIME_CONFIG)
	dword * report_timer;                		/* timer to delay sending */
												/* reports after receiving   */
	#else
	dword   report_timer[CFG_MCLISTSIZE];		/* timer to delay sending */
												/* reports after receiving   */
	#endif
	#endif										/* INCLUDE_IGMP || INCLUDE_IGMP_V2 */

	#if (INCLUDE_IGMP_V2)
	#if (INCLUDE_RUN_TIME_CONFIG)
	byte *  last_host_toreply;                  /* True if this host was the last */
												/* to reply to a query   */
	#else
	byte    last_host_toreply[CFG_MCLISTSIZE];  /* True if this host was the last */
												/* to reply to a query   */
	#endif
	int     mcast_querier;                      /* state variable determines */
												/* if querier                         */
												/* for the interface is IGMP V1 or V2 */
	int     router1_present_tmr;                /* counter is positive if */
												/* querier is V1   */

	#endif								

} MCAST_INFO;

struct _epacket 
	{
    int				length;						/* message length */
	int				who;						/* type of the allocator */	
	DWORD			ChkSumOffload;
	long			RefCount;					/* > 0 while in use; 0 if free */
    unsigned char  *data;						/* ethernet frame as seen on the wire */
	struct pbuf    *buffer;
	};

typedef struct _ether
	{
    byte			eth_dest  [ETH_ALEN];		/* where the packet is going */
    byte			eth_source[ETH_ALEN];		/* who it came from */
    word			eth_type;					/* Ethernet packet type for 802.3 */
	}ETHER;

typedef ETHER *PETHER;
typedef ETHER  ETHERPKT;

typedef	struct _iface;
typedef struct _epacket *DCU;
typedef struct _epacket  EPACKET;

typedef void			(*DEVICE_CLOSE             )(struct _iface *pi);
typedef int				(*DEVICE_XMIT              )(struct _iface *pi,DCU msg);
typedef RTIP_BOOLEAN	(*DEVICE_XMIT_DONE         )(struct _iface *pi,DCU msg,RTIP_BOOLEAN success);
typedef RTIP_BOOLEAN	(*DEVICE_OPEN              )(struct _iface *pi);
typedef RTIP_BOOLEAN	(*DEVICE_STATS             )(struct _iface *pi);
typedef RTIP_BOOLEAN	(*DEVICE_SETMCAST          )(struct _iface *pi);
typedef void			(*DEVICE_PROCESS_INTERRUPTS)(struct _iface *pi);

typedef struct _edevtable
	{											/* Hardware level access data and routines   */
    DEVICE_OPEN					open;
    DEVICE_CLOSE				close;
    DEVICE_XMIT					xmit;
    DEVICE_XMIT_DONE			xmit_done;
    DEVICE_PROCESS_INTERRUPTS	proc_interrupts;
    DEVICE_STATS				statistics;
    DEVICE_SETMCAST				setmcast;

    int							device_id;		/* device type - same as device type in iface struct */

    const char				   *device_name;

    int							minor_number;   /* minor number - if one device of a type */
												/* it is 0, if two devices, the devices   */
												/* are 0 and 1, etc.                      */

    int							iface_type;     /* interface type (ETHER_IFACE for example) */


    word						mtu;            /* MAX IP packet size; used for the following: */
												/* - to determine mss sent in TCP sync msg   */
                                				/*   if on the same network, i.e. max amount */
                                				/*   of data which can be received in one    */
                                				/*   packet; if not on the same network      */
                                				/*   send 536 for our mss)                   */
                                				/* - if need to fragment and size of         */
                                				/*   fragments                               */
                                				/* MTU = data + IP header + TCP header       */
    word						max_mss_out;    /* MAX TCP data size to send regardless */
                                				/* of mss received in TCP sync message   */
                                				/* MSS = data                            */

												/* TCP WINDOW SIZES                                                     */
												/* They should be relative to the MTU size, i.e. for a MTU of 1500, the */
												/* MSS would be 1460, therefore with window size of 5840, 4 full-sized  */
												/* packets would fit in the window                                      */
    word						window_size_in;	/* size of TCP input window */
    word						window_size_out;/* size of TCP outut window */

												/* defaults   */
    union
		{
        IOADDRESS				io_address;
        int        				comm_port;
		} default1;

    union
		{
        word					mem_address;
        /* cable type used by 3c590 device driver;                */
        /* NOTE: there is no way to override the value set in the */
        /*       device table;                                    */
        #define TENBASET    1
        #define THINNET     2
        #define THICKNET    3
        word					cable_type;
        word					baud_rate;
		} default2;

    union
		{
        int						irq;
        char					handshake_type;
		} default3;
	}EDEVTABLE;


typedef struct _edevtable  *PDEVTABLE;

typedef struct _iface_ip
	{
    byte						my_hw_addr[ETH_ALEN];       /* Ethernet address on the board */
    byte        				align[2];
    byte        				my_ip_addr[IP_LEN];         /* My IP address (192.42.55.1 for example) */
    byte        				my_ip_mask[IP_LEN];         /* subnet mask ff.ff.ff.00 for example */
    byte        				my_net_bc_ip_addr[IP_LEN];  /* My IP net-directed broadcast */
	};

typedef struct _iface_ip  IFACE_IP;

typedef struct _os_iface_control
	{
    int							index;
	}OS_IFACE_CONTROL;

struct _iface 
	{
	struct netif	lpip_iface;
	RTKSemaphore	irq_signal;
	RTKSemaphore	out_signal;
	int				minor_number;
	int	volatile	xmit_done_counter;
	dword			io_address;
    word			mem_address;				/* memory address (if not 0) */
    word			align2;
	int				irq_val;
	int				irq_no;
	MCAST_INFO		mcast;
	PDEVTABLE		pdev;						/* IO routines and device type */
    IFACE_IP		addr;						/* IP/ETHERNET address information */
	OS_IFACE_CONTROL ctrl;
	WORD			ChkSumOffloadCap;
	RTKSemaphore	sem;
	void           *DriverData;
	unsigned		max_wait;
	unsigned char  *buffer;
	struct pbuf    *send_buf;
	char			name[16];
	char			name_out[16];
	char			name_irq[16];
	unsigned 		number;
	int           (*GetLinkStatus)(struct _iface *);
    union
		{
        PETHER_STATS ether_stats;				/* ethernet specific statistics */
		} driver_stats;
	};

typedef	struct _iface  *PIFACE;
extern PIFACE  ifaces;
extern int	   dcu_size_array[5];

RTIP_BOOLEAN ks_hook_interrupt(int irq, PFVOID piface,RTIPINTFN_POINTER c_strategy,RTIPINTFN_POINTER c_interrupt,int c_arg);
void		 ks_dispatch_interrupt(int irq);
void         ks_invoke_input(PIFACE pi,DCU msg);
void         ks_invoke_output(PIFACE pi, int xmit_complete_cnt);
DCU			 os_alloc_packet_input(int nbytes, int who);
void         os_free_packet(DCU msg);
void         os_sndx_input_list(PIFACE pi, DCU msg);
byte		 ms_pm_inp(unsigned short addr);
void		 debug_error(const char *string,int type,dword val1,dword val2);
int			 xn_device_table_add(EDEVTABLE * dev, int minor_number);
void		 PhysFree(void * B, int size, int num_elements);
void        *PhysMalloc(UINT Bytes, int who);
int			 set_errno(int error);
void		 ks_sleep(dword no_ticks);
dword		 ks_ticks_p_sec(void);
dword		 ks_msec_p_tick(void);
dword		 ks_get_ticks(void);
unsigned	 ks_splx(void);
void		 ks_spl(unsigned lev);

static __inline void ks_disable(void)
{
    __asm cli
}

static __inline void ks_enable(void)
{
    __asm sti
}


#endif 	

