//*****************************************************************************
//*
//*
//*		TcpTester.cpp			
//*
//*
//*****************************************************************************
//
//	Testprogramm fr die Windows-Seite beim LWIP-Stack
//	
#include	<windows.h>
#include	<string.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<time.h>

#include	"System/WatchdogUtility.h"
#include	"System/SocketUtility.h"
#include	"System/ThreadUtility.h"

#include	"TcpTester.h"


#define 	TTE_LOG_POINTS		(1<<19)

typedef struct
	{
	TcpHandle	hTcp;
	unsigned	uPort;
	}ConnStartInfo;

typedef struct
	{
	unsigned char		ucType;
	unsigned char		ucUnused;
	unsigned char		ucTcpFlags;
	unsigned char		ucDataOffset;
	unsigned short 		usPacketSize;
	unsigned short 		usPacketData;
	unsigned			uTime;
	unsigned			uPos;
	unsigned char		aPacket[63];
	unsigned char  		ucTcpOffset;
	char				cThread[16];	
	char				cName[16];
	TteInfo				sInfo;
	}LogInfo;

typedef union
	{
	unsigned char		aData[144];
	LogInfo				sData;
	}LogPoint;


TTS_API ThreadMutex		hPrintMux		= 0;
static	int volatile	iStopThreads	= 0;
static	int volatile	iInitDone		= 0;
static	int volatile	iWriteCount		= 0;
static	int volatile	iErrorStop		= 0;
static	IpAddr			sIpAddr;
static	LogPoint		aPoints[TTE_LOG_POINTS];

//*****************************************************************************
//*
//*		TcpTesterSaveLog
//*
//*****************************************************************************
TTS_API	int TcpTesterSaveLog(const char *pFileName)
{
#if			TTE_LOG_SAVE
char		cBuffer[4096];
FILE	   *pFile;
LogPoint   *pPoint;
LogPoint	sPoint;
unsigned	uCount;
unsigned	uValue;
unsigned	uStart;
unsigned	uTime;
unsigned	uSize;
unsigned	uPos;
unsigned	uOff;
unsigned	uNum;


		pFile = fopen(pFileName,"wb");
	if(!pFile)return 1;

	uCount	= iWriteCount;
	
	if(uCount>TTE_LOG_POINTS/4*3)
		{
		uCount = TTE_LOG_POINTS/4*3;
		}

	uPos	= iWriteCount-uCount;
	uPos   %= TTE_LOG_POINTS;
	
	uTime	= ThreadTickCount();
	uStart	= aPoints[uPos].sData.uTime;

	uTime  -= uStart; 	
	uTime  /= 1000;
	uTime	= time(0)-uTime;

	uValue	= sizeof(LogPoint);
	uSize	= uCount*uValue+12;

	fwrite("AZTT" ,1,4,pFile);
	fwrite(&uSize ,1,4,pFile);
	fwrite(&uTime ,1,4,pFile);
	fwrite(&uCount,1,4,pFile);
	fwrite(&uValue,1,4,pFile);

	ThreadSleep(100);
	setvbuf(pFile,cBuffer,_IOFBF,sizeof(cBuffer));

	for(;uCount>0;uPos++,uCount--)
		{
		uPos		  	   %= TTE_LOG_POINTS;
		sPoint				= aPoints[uPos];
		sPoint.sData.uTime -= uStart;

		if(sPoint.sData.sInfo.pName)
			{
			strncpy(sPoint.sData.cName,sPoint.sData.sInfo.pName,sizeof(sPoint.sData.cName));
			}
		else{
			sPoint.sData.cName[0]=0;
			}

		if(sPoint.sData.sInfo.ucConn==0 && sPoint.sData.sInfo.usPort)
			{
			uOff = uPos;

			for(uNum=0;uNum<0x8000;uNum++)
				{
				uOff   += 1;
				uOff   %= TTE_LOG_POINTS;
				pPoint	= aPoints+uOff;

				if(pPoint->sData.sInfo.usPort!=sPoint.sData.sInfo.usPort)
					{
					continue;
					}

				if(pPoint->sData.ucTcpFlags&0x01)		// FIN
					{
					if(uNum>512)uNum=512;
					}

				if(pPoint->sData.sInfo.ucConn==0)
					{
					continue;
					}

				sPoint.sData.sInfo.ucConn = pPoint->sData.sInfo.ucConn;
				
				break;
				}
			}
		
		if(sPoint.sData.sInfo.ucConn==0 && sPoint.sData.sInfo.usPort)
			{
			uOff = uPos;

			for(uNum=0;uNum<0x8000;uNum++)
				{
				uOff   -= 1;
				uOff   %= TTE_LOG_POINTS;
				pPoint	= aPoints+uOff;

				if(pPoint->sData.sInfo.usPort!=sPoint.sData.sInfo.usPort)
					{
					continue;
					}

				if(pPoint->sData.ucTcpFlags&0x02)		// SYN
					{
					if(uNum>512)uNum=512;
					}

				if(pPoint->sData.sInfo.ucConn==0)
					{
					continue;
					}

				sPoint.sData.sInfo.ucConn = pPoint->sData.sInfo.ucConn;
				
				break;
				}
			}

		if(sPoint.sData.sInfo.usPort==0 && sPoint.sData.sInfo.ucConn)
			{
			uOff = uPos;

			for(uNum=0;uNum<0x8000;uNum++)
				{
				uOff   += 1;
				uOff   %= TTE_LOG_POINTS;
				pPoint	= aPoints+uOff;

				if(pPoint->sData.sInfo.ucConn!=sPoint.sData.sInfo.ucConn)
					{
					continue;
					}

				if(pPoint->sData.ucTcpFlags&0x01)		// FIN
					{
					if(uNum>512)uNum=512;
					}

				if(pPoint->sData.sInfo.usPort==0)
					{
					continue;
					}

				sPoint.sData.sInfo.usPort = pPoint->sData.sInfo.usPort;

				break;
				}
			}

		if(sPoint.sData.sInfo.usPort==0 && sPoint.sData.sInfo.ucConn)
			{
			uOff = uPos;

			for(uNum=0;uNum<0x8000;uNum++)
				{
				uOff   -= 1;
				uOff   %= TTE_LOG_POINTS;
				pPoint	= aPoints+uOff;

				if(pPoint->sData.sInfo.ucConn!=sPoint.sData.sInfo.ucConn)
					{
					continue;
					}

				if(pPoint->sData.ucTcpFlags&0x02)		// SYN
					{
					if(uNum>512)uNum=512;
					}

				if(pPoint->sData.sInfo.usPort==0)
					{
					continue;
					}

				sPoint.sData.sInfo.usPort = pPoint->sData.sInfo.usPort;

				break;
				}
			}

		fwrite(&sPoint,1,uValue,pFile);	
		}

	fclose(pFile);


#endif 	

return 0;
}


//*****************************************************************************
//*
//*		TcpTesterPacket
//*
//*****************************************************************************
TTS_API	int TcpTesterPacket(const TteInfo *pInfo,void *pPacket,unsigned uSize,unsigned uType)
{
LogInfo		   *pData; 
const char	   *pThread;
unsigned char  *pPtr=(unsigned char*)pPacket;
unsigned		uPortS;
unsigned		uPortD;
unsigned		uBytes;
unsigned		uPos;
unsigned		uLen;
unsigned		uAll;

	

	if(!pInfo|| iErrorStop)return 0;
//	ThreadMutexWait(hPrintMux);
	
	uPos				= InterlockedExchangeAdd((LPLONG)&iWriteCount,1);
	uPos			   %= TTE_LOG_POINTS;

	pData				= &aPoints[uPos].sData;
	pData->ucType		= uType;
	pData->ucUnused		= 0;
	pData->usPacketSize	= uSize;
	pData->sInfo		=*pInfo; 
	pData->uTime		= ThreadTickCount();
	pData->uPos			= uPos;
	
	   pThread			= ThreadGetName();
	if(pThread)
		{
		strncpy(pData->cThread,pThread,sizeof(pData->cThread)-1);
		pData->cThread[sizeof(pData->cThread)-1]=0;
		}
	else{
		sprintf(pData->cThread,"%04Xh",GetCurrentThreadId());
		}
	
	pPtr				= (unsigned char*)pPacket;
	uBytes				= uSize;

	if(uBytes>24 && pPtr[12]==0x08 && pPtr[13]==0x00 && pPtr[23]==0x06)
		{
		pPtr			   +=  14;
		uBytes			   -=  14;
		uLen				= (pPtr[0]&0x0F)*4;
		uAll				=  pPtr[2]*256+pPtr[3];

		pData->ucType	   +=  4;
		pData->ucTcpOffset	=  uLen+14;
		pData->ucTcpFlags	=  pPtr[uLen+13];
		uPortS				=  pPtr[uLen+0]*256+pPtr[uLen+1];
		uPortD				=  pPtr[uLen+2]*256+pPtr[uLen+3];
		uLen			   += (pPtr[uLen+12]>>4)*4;
		pData->ucDataOffset	=  uLen+14;
		pData->usPacketData	=  uAll-uLen;

		if(pData->sInfo.usPort==0)
			{
			if(uPortD==TTE_PORT)pData->sInfo.usPort=uPortS;
			if(uPortS==TTE_PORT)pData->sInfo.usPort=uPortD;
			}
		}
	else{
		pData->ucTcpOffset = 0;
		}


	if(uSize>sizeof(pData->aPacket))
		{
		uSize=sizeof(pData->aPacket);
		}

	memcpy(pData->aPacket,pPacket,uSize);
	memset(pData->aPacket+uSize,0,sizeof(pData->aPacket)-uSize);


//	ThreadMutexRelease(hPrintMux);



return 1;
}

//*****************************************************************************
//*
//*		TcpTesterError
//*
//*****************************************************************************
TTS_API	void TcpTesterError(int iConn,int iTurn,int iPort,const char *pFormat,int iParam1,int iParam2)
{
static unsigned	uDone=0;
unsigned		uTime;
TteInfo			sInfo;


	if(iErrorStop)return;

	memset(&sInfo,0,sizeof(sInfo));
	sInfo.ucConn	= iConn;
	sInfo.ucTurn	= iTurn;
	sInfo.usPort	= iPort;
	sInfo.iParam1	= iParam1;
	sInfo.iParam2	= iParam2;
	sInfo.pName		= pFormat;

	if(!memcmp(sInfo.pName,"C%03i  ",7))
		{
		sInfo.pName+=7;
		}

	TcpTesterPacket(&sInfo,0,0,254);
	
	iErrorStop		= 1;
	uTime			= GetTickCount();

	ThreadSleep(500);

	if(!hPrintMux)hPrintMux=ThreadMutexInit();

	ThreadMutexWait(hPrintMux);
	printf(pFormat,iConn,iParam1,iParam2);

	if(!uDone)
		{
		uDone = 1;
		TcpTesterSaveLog("D:\\IpError.tte");
		}

	ThreadMutexRelease(hPrintMux);


}

//*****************************************************************************
//*
//*		TcpTesterWorker
//*
//*****************************************************************************
static void TcpTesterWorker(void *pParam)
{
ConnStartInfo  *pStart=(ConnStartInfo*)pParam;
unsigned char 	aBuffer[0x500];
WatchdogHandle	hWatchdog;
unsigned		uPort;
TteInfo			sInfo;
TcpHandle		hTcp;
int				iTurn;
int				iConn;
int				iRet;
int				iLen;



	hWatchdog	= WatchdogRegister(60000,"TcpTesterWorker");
	uPort		= pStart->uPort;
	hTcp		= pStart->hTcp;
	iConn		= 0;
	iTurn		= 0;
	iRet		= 0;
	
	memset(&sInfo,0,sizeof(sInfo));

	free(pStart);

	sInfo.pName = "start";
	TcpTesterLog(&sInfo);

	while(!iStopThreads)
		{
		WatchdogTrigger(hWatchdog);

		sInfo.iParam1	=  4;	
		sInfo.iParam2	=  iRet;	
		sInfo.pName		= "get A";
		TcpTesterLog(&sInfo);

		iRet = TcpGetWait(hTcp,&iLen,4,10000);

		if(iRet!=4)
			{
			TcpTesterError(iConn,iTurn,uPort,"C%03i  recv error A (%i/%i)\n",iRet,4);
			break;
			}

		sInfo.ucConn	= (iLen>>16)&0xFF;
		sInfo.ucTurn	= (iLen>>24)&0xFF;
		sInfo.iParam1	= (iLen  )&0xFFFF;
		iConn			= (iLen>>16)&0xFF;
		iTurn			= (iLen>>24)&0xFF;
		iLen			= (iLen  )&0xFFFF;

		if(uPort && iConn>0 && iConn<=TTE_MAX_CONN)
			{
			sInfo.usPort = uPort;
			uPort		 = 0;
			}

		if(iLen>sizeof(aBuffer))
			{
			TcpTesterError(iConn,iTurn,uPort,"C%03i  recv error B (%i/%i)\n",iRet,iLen);
			break;
			}

		sInfo.pName		= "get B";
		TcpTesterLog(&sInfo);
	
		iRet = TcpGetWait(hTcp,aBuffer,iLen,6000);

		if(iRet!=iLen)
			{
			TcpTesterError(iConn,iTurn,uPort,"C%03i  recv error C (%i/%i)\n",iRet,iLen);
			break;
			}
		
		WatchdogTrigger(hWatchdog);

		sInfo.iParam1	= iRet;
		sInfo.pName		= "put C";
		TcpTesterLog(&sInfo);

		iRet = TcpPut(hTcp,aBuffer,iLen);

		if(iRet!=iLen)
			{
			TcpTesterError(iConn,iTurn,uPort,"C%03i  send error D (%i/%i)\n",iRet,iLen);
			break;
			}
		
		WatchdogTrigger(hWatchdog);
		
		sInfo.iParam1	= iRet;
		sInfo.pName		= "put D";
		TcpTesterLog(&sInfo);

		aBuffer[1] |= 0x80;

		iRet = TcpPut(hTcp,aBuffer,iLen);

		if(iRet!=iLen)
			{
			TcpTesterError(iConn,iTurn,uPort,"C%03i  send error E (%i/%i)\n",iRet,iLen);
			break;
			}
		
		WatchdogTrigger(hWatchdog);
		}
			
	sInfo.pName		= "close";
	TcpTesterLog(&sInfo);

	if(hTcp)TcpClose(hTcp);

	WatchdogUnregister(hWatchdog);


}

//*****************************************************************************
//*
//*		TcpTesterListen
//*
//*****************************************************************************
static void TcpTesterListen(void *pParam)
{
unsigned short	usPort;
ConnStartInfo  *pStart;
WatchdogHandle	hWatchdog;
TcpHandle		hServer=0;
TcpHandle		hClient=0;
TteInfo			sInfo;


	hWatchdog = WatchdogRegister(60000,"TcpTesterListen");

	memset(&sInfo,0,sizeof(sInfo));

	while(!iStopThreads)
		{
		WatchdogTrigger(hWatchdog);

		   hServer = TcpOpen(0,TTE_PORT,TCP_SERVER);
		if(hServer)break;
		
		TcpTesterError(0,0,0,"Cxxx  can't open server socket\n");
		ThreadSleep(1000);
		}


	while(!iStopThreads)
		{
		WatchdogTrigger(hWatchdog);

			hClient= TcpAcceptWait(hServer,0,&usPort,5000);
		if(!hClient)continue;
		
		pStart			= (ConnStartInfo*)malloc(sizeof(ConnStartInfo));
		pStart->hTcp	= hClient;
		pStart->uPort	= usPort;

		sInfo.pName		= "close";
		sInfo.usPort	= usPort;
		TcpTesterLog(&sInfo);

		ThreadStart(TcpTesterWorker,0x4000,pStart,0);
		
		hClient			= 0;
		}


	if(hServer)TcpClose(hServer);
	if(hClient)TcpClose(hClient);

	WatchdogUnregister(hWatchdog);
}

//*****************************************************************************
//*
//*		TcpTesterConnection
//*
//*****************************************************************************
static void TcpTesterConnection(void *pParam)
{
int				iConn=(int)pParam;
unsigned char 	aSend[0x500];
unsigned char 	aRecv[0x500];
WatchdogHandle	hWatchdog;
TcpHandle		hTcp=0;
TteInfo			sInfo;
int				iTurn;
int				iRet;
int				iLen;
int				iPos;


	hWatchdog = WatchdogRegister(60000,"TcpTesterConnection");


	memset(&sInfo,0,sizeof(sInfo));
	sInfo.ucConn = iConn;

	iTurn = 0;
	iRet  = 0;	

	while(!iStopThreads)
		{
		WatchdogTrigger(hWatchdog);

		if(!hTcp)
			{
			iRet  = 0;
			iTurn = 0;
			ThreadSleep(200+rand()%512);

				hTcp = TcpOpenWait(&sIpAddr,TTE_PORT,10000);
			if(!hTcp)
				{
				TcpTesterError(iConn,iTurn,0,"C%03i  can't connect\n");
				continue;
				}
			
			sInfo.ucTurn	= iTurn;
			sInfo.iParam1	= 0;
			sInfo.iParam2	= 0;
			sInfo.pName		= "connect to server";
			sInfo.usPort	= 0;
			TcpTesterLog(&sInfo);
			
			ThreadMutexWait(hPrintMux);
			printf("C%03i  connect to server\n",iConn);
			ThreadMutexRelease(hPrintMux);
			}

		iTurn++;
		iLen		= 0x101+(rand()&0x3FF);
		aSend[0]	= iLen;
		aSend[1]	=(iLen/256);
		aSend[2]	= iConn;
		aSend[3]	= iTurn;
		
		sInfo.ucTurn	= iTurn;
		sInfo.iParam1	= 4;
		sInfo.iParam2	= iRet;
		sInfo.pName		= "put A";
		sInfo.usPort	= 0;
		TcpTesterLog(&sInfo);
		WatchdogTrigger(hWatchdog);

		iRet = TcpPut(hTcp,aSend,4);

		sInfo.ucTurn	= iTurn;
		sInfo.iParam1	= 4;
		sInfo.iParam2	= iRet;
		sInfo.pName		= "put A done";
		sInfo.usPort	= 0;
		TcpTesterLog(&sInfo);
		WatchdogTrigger(hWatchdog);

		if(iRet!=4)
			{
			TcpTesterError(iConn,iTurn,0,"C%03i  send error A (%i/%i)\n",iRet,4);
			TcpClose(hTcp);
			hTcp = 0;
			continue;
			}
		
		WatchdogTrigger(hWatchdog);

		for(iPos=4;iPos<iLen;iPos++)
			{
			aSend[iPos] = rand();
			}

		sInfo.ucTurn	= iTurn;
		sInfo.iParam1	= iLen;
		sInfo.iParam2	= iRet;
		sInfo.pName		= "put B";
		sInfo.usPort	= 0;
		TcpTesterLog(&sInfo);
		WatchdogTrigger(hWatchdog);

		iRet = TcpPut(hTcp,aSend,iLen);

		sInfo.ucTurn	= iTurn;
		sInfo.iParam1	= iLen;
		sInfo.iParam2	= iRet;
		sInfo.pName		= "put B done";
		sInfo.usPort	= 0;
		TcpTesterLog(&sInfo);  
		WatchdogTrigger(hWatchdog);

		if(iRet!=iLen)
			{
			TcpTesterError(iConn,iTurn,0,"C%03i  send error B (%i/%i)\n",iRet,iLen);
			TcpClose(hTcp);
			hTcp = 0;
			continue;
			}
		
		sInfo.ucTurn	= iTurn;
		sInfo.iParam1	= iLen;
		sInfo.iParam2	= iRet;
		sInfo.pName		= "get C";
		sInfo.usPort	= 0;
		TcpTesterLog(&sInfo);
		WatchdogTrigger(hWatchdog);

		iRet = TcpGetWait(hTcp,aRecv,iLen,10000);

		sInfo.ucTurn	= iTurn;
		sInfo.iParam1	= iLen;
		sInfo.iParam2	= iRet;
		sInfo.pName		= "get C done";
		sInfo.usPort	= 0;
		TcpTesterLog(&sInfo);

		if(iRet!=iLen)
			{
			TcpTesterError(iConn,iTurn,0,"C%03i  recv error A (%i/%i)\n",iRet,iLen);
			TcpClose(hTcp);
			hTcp = 0;
			continue;
			}

		WatchdogTrigger(hWatchdog);
		
		if(memcmp(aSend,aRecv,iLen))
			{
			TcpTesterError(iConn,iTurn,0,"C%03i  data error A (%i)\n",iLen);
			TcpClose(hTcp);
			hTcp = 0;
			continue;
			}

		sInfo.ucTurn	= iTurn;
		sInfo.iParam1	= iLen;
		sInfo.iParam2	= iRet;
		sInfo.pName		= "get D";
		sInfo.usPort	= 0;
		TcpTesterLog(&sInfo);

		iRet = TcpGetWait(hTcp,aRecv,iLen,10000);

		sInfo.ucTurn	= iTurn;
		sInfo.iParam1	= iLen;
		sInfo.iParam2	= iRet;
		sInfo.pName		= "get D done";
		sInfo.usPort	= 0;
		TcpTesterLog(&sInfo);

		if(iRet!=iLen)
			{
			TcpTesterError(iConn,iTurn,0,"C%03i  recv error B (%i/%i)\n",iRet,iLen);
			TcpClose(hTcp);
			hTcp = 0;
			continue;
			}

		aSend[1] |= 0x80;
		
		if(memcmp(aSend,aRecv,iLen))
			{
			TcpTesterError(iConn,iTurn,0,"C%03i  data error B (%i)\n",iLen);
			TcpClose(hTcp);
			hTcp = 0;
			continue;
			}
		
		//ThreadSleep(2000+rand()%512);
		WatchdogTrigger(hWatchdog);
		}

	if(hTcp)TcpClose(hTcp);

	WatchdogUnregister(hWatchdog);

}

//*****************************************************************************
//*
//*		TcpTesterInit
//*
//*****************************************************************************
TTS_API	int TcpTesterInit(int iConnections,const char *pIpAddress)
{
int		iPos=0;

	
	if(iInitDone)return 0;

	iInitDone		= 1;
	iStopThreads	= 0;

	if(!hPrintMux)
		{
		hPrintMux=ThreadMutexInit();
		}

	if(iConnections>0)
		{
		#if  TTE_LOG_SAVE==1
		iErrorStop = 1;
		#endif 	

		if(iConnections>TTE_MAX_CONN)
			{
			iConnections = TTE_MAX_CONN;
			}
		
		if(!IpAddress(&sIpAddr,pIpAddress))
			{
			iInitDone = 0;
			return 0;
			}
		
		for(iPos=0;iPos<iConnections;)
			{
			iPos++;
			ThreadStart(TcpTesterConnection,0x4000,(void*)iPos,0);
			}
		}
	else{
		#if  TTE_LOG_SAVE==2
		iErrorStop = 1;
		#endif 	

		ThreadStart(TcpTesterListen,0x4000,(void*)iPos,0);
		}
		
			

return 1;
}


//*****************************************************************************
//*
//*		TcpTesterExit
//*
//*****************************************************************************
TTS_API	int TcpTesterExit()
{

	if(!iInitDone)return 0;
	
	iStopThreads = 1;



return 1;
}
